// Learn TypeScript:
//  - https://docs.cocos.com/creator/manual/en/scripting/typescript.html
// Learn Attribute:
//  - https://docs.cocos.com/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - https://docs.cocos.com/creator/manual/en/scripting/life-cycle-callbacks.html

const {ccclass, property} = cc._decorator;

@ccclass
export default class NewClass extends cc.Component {

    @property(cc.Label)
    label: cc.Label = null;

    @property
    text: string = 'hello';
    startPoint: any;
    rigidBody: any;
    tween: any;

    // LIFE-CYCLE CALLBACKS:
    onPreSolve(contact, selfCollider, otherCollider) {
        if (otherCollider.node.name.includes('disk')) {
            this.moveEnd();
            this.scheduleOnce(()=>{
                console.error('1');
                this.rigidBody.type = cc.RigidBodyType.Dynamic;
                otherCollider.node.getComponent(cc.RigidBody).type = cc.RigidBodyType.Kinematic;
                const joint = this.node.getComponent(cc.WeldJoint);
                joint.enabled =true;
                joint.connectedBody = otherCollider.node;
            })
            // joint.anchor = cc.v2(-51.7, -1.1);
        }
        }

        onPostSolve(contact, selfCollider, otherCollider) {
            this.scheduleOnce(()=>{
                this.rigidBody.type = cc.RigidBodyType.Kinematic;
                otherCollider.node.getComponent(cc.RigidBody).type = cc.RigidBodyType.Dynamic;
            })
        }

    onLoad () {
        this.rigidBody = this.node.getComponent(cc.RigidBody);
        this.rigidBody.type = cc.RigidBodyType.Kinematic;
        this.initEvent();
    }

    initEvent() {
        this.node.on(cc.Node.EventType.TOUCH_START, this._touchStartEvent, this);
        this.node.on(cc.Node.EventType.TOUCH_MOVE, this._touchMoveEvent, this);
        this.node.on(cc.Node.EventType.TOUCH_END, this._touchEndEvent, this);
        this.node.on(cc.Node.EventType.TOUCH_CANCEL, this._touchCancelEvent, this);
    }

    _touchStartEvent(event: cc.Event.EventTouch) {
        this.startPoint = event.getPreviousLocation();
    }
    _touchMoveEvent(event: cc.Event.EventTouch) {
        // this.points.push(event.getLocation());
        // if (this.points.length > 20) {
        //         this.points.shift();
        //     }
        //     const averagePoint = new cc.Vec2(0, 0);
        //     this.points.forEach((point) => {
        //             averagePoint.x += point.x;
        //             averagePoint.y += point.y;
        //         })
        //         averagePoint.multiplyScalar(1 / this.points.length);
                
        //         const delta = new cc.Vec2(event.getLocation().x - averagePoint.x, event.getLocation().y - averagePoint.y);
        //         let dir = delta;
        let dir = cc.v2(event.getLocation().x - this.startPoint.x, event.getLocation().y - this.startPoint.y);
        // clientEvent.dispatchEvent('move', dir);
        this.move(dir);
    }

    _touchEndEvent(event: cc.Event.EventTouch) {
        // this.points = [];
        // clientEvent.dispatchEvent('moveEnd');
    }

    _touchCancelEvent(event: cc.Event.EventTouch) {
        // clientEvent.dispatchEvent('moveEnd');
        this.moveEnd();
    }

    move(dir) {
        // this.node.position = dir;
        this.tween = cc.tween(this.node)
        .to(0.7, {position: dir})
        .start()
        // this.rigidBody.awake = true;
        // cc.director.getPhysicsManager().enabled = false;
    }
    moveEnd() {
        if (this.tween) {
            this.tween.stop();
        }
        // cc.director.getPhysicsManager().enabled = true;

    }

    start () {

    }

    // update (dt) {
    // }
}
